// C Source File
// Created 29/05/03; 09:42:56

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function

void getk(void)
{
 short quit=0;
	do
	{
		if(_rowread(0x70)&0x1 || _rowread(0x3F)&0x1 || _rowread(0x5F)&0x1|| _rowread(0x7E)&0x10)
		quit=2;
	}
	while(quit!=2);
}
void aff(char *str)
{
	FontSetSys(F_8x10);
  DrawStrXY(15,65,str,A_REPLACE);
	getk();
}




void _main(void)
{
short i=0,j=0,temp=0,matx=0,maty=0,quit=0,raqlar=28,perdu=0,foir=0,num=0,map=0,vit=2000,vie=3,count=0,dev=0;
float xpos=80,xpos2=80,xaug=0,yaug=0,x=80,y=85,a=1,b=1;
char str[20];
short pull[1]={4};
INT_HANDLER save_int_1;
save_int_1 = GetIntVec(AUTO_INT_1);
//LCD_BUFFER buffer_mem; 
HANDLE menu1=PopupNew(NULL,60);
PopupAddText(menu1,-1,"1",2500);
PopupAddText(menu1,-1,"2",2000);
PopupAddText(menu1,-1,"3",1600);
PopupAddText(menu1,-1,"4",1200);
PopupAddText(menu1,-1,"5",900);
PopupAddText(menu1,-1,"6",500);
PopupAddText(menu1,-1,"7",250);
PopupAddText(menu1,-1,"8",0);
HANDLE dial = DialogNewSimple(130,50);
DialogAddTitle(dial,"Propanoid V1.0 Beta", BT_CANCEL, BT_OK );
DialogAddText(dial, 10,13,"Propanoid V.1.0 Beta 05/2003");
DialogAddText(dial, 10,20,"By Bordoni Nils");
DialogAddPulldown(dial, 10, 28, "Game speed:", menu1, 0 );

temp=DialogDo(dial, CENTER, CENTER,&str, pull );
if(temp==KEY_ESC)goto fin;
vit=pull[0];
if(vit==4)
vit=2500;
while(vit==4);
HeapFree(dial);
HeapFree(menu1);

char mat1[8][9]=                     //short
 {{0,1,1,1,0,1,1,1,0},
  {1,0,1,1,0,1,1,0,1},
  {1,1,0,1,0,1,0,1,1},
  {1,1,1,0,3,0,1,1,1},
  {0,0,0,0,2,0,0,0,0},
  {1,1,1,0,1,0,1,1,1},
  {1,1,0,1,1,1,0,1,1},
  {0,0,0,0,0,0,0,0,0}};



SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
static unsigned char ball[]={0x70,0xF8,0xF8,0xF8,0x70,0x00};
static unsigned long raq[]={0x7FFFFFE0,0xD5555550,0xAAAAAAB0,0x7FFFFFE0};
static unsigned short brik[]={0x3FFC,0x4002,0xBFFD,0xBFFD,0x4002,0x3FFC};
static unsigned short brik2[]={0x3FFC,0x7FFE,0xFFFF,0xFFFF,0x7FFE,0x3FFC};
static unsigned short brikf[]={0x3FFC,0x524A,0x88A1,0xA295,0x4846,0x3FFC};
deb:


switch(map)
{
case(1):

 for(i=0;i<8;i++)
 {
 	i++;
 	for(j=0;j<8;j++)
 	{
 	  j++;
 		mat1[i][j]=1;
 	}
 }
break;
case(2):
 for(i=0;i<7;i++)
 {
 	for(j=0;j<8;j++)
 	{
 	  j++;
 	  mat1[i][j]=1;
 	  if(i==3)
 	  mat1[i][j]=2;
 	  if(i==7 && j==4)
 	  mat1[i][j]=3;
 		
 	}
 }
break;
case(3):

 for(i=0;i<7;i++)
 {
 	for(j=0;j<8;j++)
 	{
 	  
 	  mat1[i][j]=1;
 	  if(i==3)
 	  mat1[i][j]=2;
 	  if(i==7 && j==4)
 	  mat1[i][j]=3;
 	  if(i+j==4)
 	  mat1[i][j]=0;
 	  if(i+j==5)
 	  mat1[i][j]=0;
 	  
 		
 	}
 }
break;
}
con:
x=80;y=85;a=0;b=0;xaug=0;yaug=-1;xpos=80;
quit=0;
perdu=0;
clrscr();
num=0;
for(i=0;i<8;i++)            //i<7
{
	for(j=0;j<9;j++)
	{
	 temp=mat1[i][j];
		if(temp==1)
		{
			Sprite16(j*17+4,i*8,6,brik,LCD_MEM,SPRT_XOR);
			num++;
		}
		if(temp==2)
		{
		 Sprite16(j*17+4,i*8,6,brik2,LCD_MEM,SPRT_XOR);
			num++;				
		}
		if(temp==3)
		{
			Sprite16(j*17+4,i*8,6,brikf,LCD_MEM,SPRT_XOR);
			num++;
		}
		
	}
}
yaug=-0.5;
xaug=0.5;

Sprite8(x, y, 5, ball, LCD_MEM, SPRT_XOR);
Sprite32(xpos2, 88, 4, raq, LCD_MEM, SPRT_XOR);
DrawLine(0,93,159,93,A_NORMAL);

do
{

for(i=0;i<8;i++)
{
for(j=0;j<vit;j++)
{
}
}

FontSetSys(F_4x6); 
sprintf(str,"Balls:%i Briks:%i  ",vie,num);               //status line
DrawStr(0,95,str,A_REPLACE);

a=x;
b=y;
x=x+xaug;
y=y+yaug;
if(xaug>2)
 xaug=1.9;
if(xaug<-2)
 xaug=-1.9;

if(x>154)
{
xaug=-xaug;
x=154;
}
if(x<1)
{
	xaug=-xaug;
	x=1;
}
if(y<1)
{
yaug=-yaug;
y=1;
}
if(y>82)
{
	if(y>88)              //x+5<xpos || x>xpos+raqlar+2)
	{	
	 perdu=1;
	 quit=1;
	}
	if(x+5>xpos && x<xpos+raqlar+2)               //raquette
	{
	 
	 if(_rowread(0x7E)&0x8 && xpos<144)
   xaug+=0.5;
   if(_rowread(0x7E)&0x2 && xpos>0)
   xaug-=0.5;
   xaug=xaug+(x-(xpos+(raqlar+1)/2))/30;
   yaug=-abs(1.5-xaug/2);
   	if(yaug>-0.2 && yaug<0)
 		yaug=-0.2;
		if(yaug<0.2 && yaug>0)
 		yaug=-0.2;
	}
}
if(dev==1)
{
if(vit>100)
vit-=100;
sprintf(str,"Fire Brik:%i  ",count);
DrawStr(110,95,str,A_REPLACE);
if(count>0)
count--;																									//counter
if(count==0)
{
	ScrRectFill(&(SCR_RECT){{0, 94, 159, 99}},&(SCR_RECT){{0, 0, 159, 99}},A_REVERSE);
	dev=0;
	if(vit>0)
	vit+=100;
}
}

if(xaug==0 || x==a)
foir++;
if(foir==300)
{
	foir=0;
	x+=2;
}

matx=floor((x-1)/17);
if(matx==-1)
matx=0;
maty=floor((y+2)/8);
if(maty<8)
  {
  	
  	if(mat1[maty][matx]!=0)
  	{
  	  temp=mat1[maty][matx];
  	  
  		i=matx*17+14;   		//6+17/2        //centre des cases
  		j=maty*8+3;					//6/2
  		if(temp==1)
  		{
  			Sprite16(matx*17+4,maty*8,6,brik,LCD_MEM,SPRT_XOR);
  			mat1[maty][matx]=0;
  			num--;
  		}
  		if(temp==2)
  		{
  			Sprite16(matx*17+4,maty*8,6,brik,LCD_MEM,SPRT_XOR);
  			Sprite16(matx*17+4,maty*8,6,brik2,LCD_MEM,SPRT_XOR);
  	  	mat1[maty][matx]=1;
  		}
  		if(temp==3)
  		{
  			Sprite16(matx*17+4,maty*8,6,brikf,LCD_MEM,SPRT_XOR);
  			mat1[maty][matx]=0;
  			num--;
  			dev=1;
  			count=600;
  		}
  		if(dev==0)
  		{
  		if(x>i+7 && xaug<0)														//rebond
  		xaug=-xaug;
  		if(x<i-7 && xaug>0)
  		xaug=-xaug;
  		if(y<j-2 && yaug>0)
  		yaug=-yaug;
  		if(y>j+1 && yaug<0)
  		yaug=-yaug;
  		}
  		if(num==0)
  		{
  			quit=1;
  			perdu=2;
  		}
  		
  	}
  	
  	
  }



Sprite8(a, b, 5, ball, LCD_MEM, SPRT_XOR);
Sprite8(x, y, 5, ball, LCD_MEM, SPRT_XOR);

for(j=0;j<3;j++)
{
Sprite32(xpos2, 88, 4, raq, LCD_MEM, SPRT_XOR);
Sprite32(xpos, 88, 4, raq, LCD_MEM, SPRT_XOR);

xpos2=xpos;
if(_rowread(0x5F)&0x1)
{
	ST_showHelp("Game paused");
	getk();
	ScrRectFill(&(SCR_RECT){{0, 94, 159, 99}},&(SCR_RECT){{0, 0, 159, 99}},A_REVERSE);
}

if(_rowread(0x7E)&0x8 && xpos<159-raqlar)
xpos++;
if(_rowread(0x7E)&0x2 && xpos>0)
xpos--;
if(_rowread(0x3F)&0x1)
quit=1;
}

	
	
}
while(quit==0);
if(perdu==2)
{
 	//clrscr();
  aff("Level completed !");

	if(map<2)
	{
	map++;
	goto deb;
	}
	if(map==3)
	map=1;
	goto deb;
	
}



if (perdu==1)
{ 
	vie--;
	if(vie>0){aff("  Ball lost !");goto con;}
  aff("  Game over...");
}
fin:
SetIntVec(AUTO_INT_1, save_int_1); // Restaure l'AUTO_INT_1
}
